//  Abs.java - Demonstrate the use of an abstract class

abstract class Silverware {
    Silverware() { ++nNumPieces; }
    void wash() {
        System.out.println("Toss it in the dishwasher, of course!");
    }
    protected double dCost;
    protected static int nNumPieces = 0;
}

class Fork extends Silverware {
    void stab() {
        System.out.println("Ouch!");
    }
    protected int nNumTines;
}

class Knife extends Silverware {
    Knife() { dSharpness = 98.5; }
    void slice() {
        System.out.println("You're bleeding...");
    }
    protected double dSharpness;
}

class Spoon extends Silverware {
    Spoon() { dCapacity = 1.2;  /* ounces */ }
    void slurp() {
        System.out.println("Slurp!");
    }
    protected double dCapacity;
}

class SoupSpoon extends Spoon {
    void slurp() {
        System.out.println("SLURP !!");
    }
    protected double dCapacity = 4 * super.dCapacity;
}

public class Abs {

    Abs() {
        Knife knife = new Knife();
        knife.slice();
        knife.wash();

        Spoon spoon = new Spoon();
        spoon.slurp();
        spoon.wash();

        SoupSpoon soupSpoon = new SoupSpoon();
        soupSpoon.slurp();

        System.out.println();
        System.out.println("Soup spoon capacity is " + soupSpoon.dCapacity + " ounces");
        System.out.println("Number of pieces of silverware is " + Silverware.nNumPieces);
    }

    public static void main(String[] args) {
        System.out.println("Running Abs...");
        System.out.println();
        new Abs();
        System.out.println("That's all, folks!");
        System.out.println();
    }

}

/* ===== Output from the above program =====

Running Abs...

You're bleeding...
Toss it in the dishwasher, of course!
Slurp!
Toss it in the dishwasher, of course!
SLURP !!

Soup spoon capacity is 4.8 ounces
Number of pieces of silverware is 3
That's all, folks!

===== End of Output ===== */
